#include                "tap.h"
#include                "LibFireBird.h"

#define PROGRAMNAME     "VolKeyPatch CRP"
#define VERSION         "V1.0"

TAP_ID                  (0x8E0A424F);
TAP_PROGRAM_NAME        (PROGRAMNAME " " VERSION);
TAP_PROGRAM_VERSION     (VERSION);
TAP_AUTHOR_NAME         ("FireBird");
TAP_DESCRIPTION         ("Maps the WHITE key to the OPTION code");
TAP_ETCINFO             (__DATE__);

bool (*Orig_PutKeyEvt)(dword a1);

bool Hooked_PutKeyEvt(dword KeyParam)
{
  dword                 KeyFlags;
  dword                 State, SubState;
  bool                  DoNotPatch;

  KeyFlags = KeyParam & 0xfffe0000;
  KeyParam = KeyParam & 0x0001ffff;

  TAP_GetState(&State, &SubState);

  DoNotPatch = FALSE;
  if(State == STATE_FileList && SubState == SUBSTATE_PvrList) DoNotPatch = TRUE;    //File List
  if(State == STATE_List && SubState == SUBSTATE_ServiceList) DoNotPatch = TRUE;    //Service List, Favorite List
  if(State == STATE_Epg && SubState == SUBSTATE_Epg) DoNotPatch = TRUE;             //EPG
  if(State == STATE_Menu && SubState == SUBSTATE_TimerMenu) DoNotPatch = TRUE;      //Timer menu
  if(State == STATE_Menu && SubState == SUBSTATE_UCCList) DoNotPatch = TRUE;        //Youtube
  if(SubState == SUBSTATE_PvrPlayingSearch) DoNotPatch = TRUE;                      //Cut button during PVR playing search bar

  if(!DoNotPatch && (KeyParam == RKEY_Ab)) KeyParam = 0x10049;  //White (Option)

  return Orig_PutKeyEvt(KeyParam | KeyFlags);
}

dword TAP_EventHandler(word event, dword param1, dword param2)
{
  (void) param2;

  if(event == EVT_STOP && param1 < 2)
  {
    UnhookFirmware("_Z9PutKeyEvtj", Hooked_PutKeyEvt, (void*)&Orig_PutKeyEvt);
    TAP_Exit();
  }

  return param1;
}

int TAP_Main(void)
{
  //Hook the key event sink
  if(!HookFirmware("_Z9PutKeyEvtj", Hooked_PutKeyEvt, (void*)&Orig_PutKeyEvt)) return 0;

  return 1;
}
