#include                "tap.h"
#include                "LibFireBird.h"
#include                "RemoteSwitch.h"

#define PROGRAM_NAME    "RemoteSwitch"

TAP_ID                  (0x8E0A4214);
TAP_PROGRAM_NAME        (PROGRAM_NAME" "VERSION);
TAP_AUTHOR_NAME         ("FireBird");
TAP_DESCRIPTION         ("Activates the remote modes set by RemoteSwitchGUI");
TAP_ETCINFO             (__DATE__);

void UpdateIrDevice(void);
void LoadINI(void);

bool                    Mode[NRRCUMODES+1];  //Mode[0] is not used

dword TAP_EventHandler(word event, dword param1, dword param2)
{
  (void) event;
  (void) param2;

  return param1;
}

void UpdateIrDevice(void)
{
  int i, Index;

  //Deactivate all filters
  for(Index = 0; Index < 4; Index++)
  {
    SetRemoteMode(1, Index, FALSE);
  }

  //Now program every active mode
  Index = 0;
  for(i = 1; i <= NRRCUMODES; i++)
  {
    if(Mode[i])
    {
      SetRemoteMode(i, Index, TRUE);
      Index++;
    }
  }
}

void CreateRootDir(void)
{
  //Check & Create Folders
  HDD_TAP_PushDir();
  HDD_ChangeDir("/ProgramFiles");
  if(!TAP_Hdd_Exist("Settings")) TAP_Hdd_Create("Settings", ATTR_FOLDER);
  HDD_ChangeDir("Settings");
  if(!TAP_Hdd_Exist("RemoteSwitch")) TAP_Hdd_Create("RemoteSwitch", ATTR_FOLDER);
  HDD_TAP_PopDir();
}

void LoadINI(void)
{
  dword                 i;
  char                  Key[8];
  INILOCATION           INILocation;

  TAP_Hdd_ChangeDir(ROOTDIR);
  for(i = 1; i <= NRRCUMODES; i++)
    Mode[i] = TRUE;

  INILocation = INIOpenFile(INIFILENAME, NULL);
  if (INILocation == INILOCATION_NewFile)
  {
    INICloseFile();
  }
  else
  {
    for(i = 1; i <= NRRCUMODES; i++)
    {
      TAP_SPrint(Key, "Mode%d", i);
      Mode[i] = INIGetInt(Key, 1, 0, 1) != 0;
    }
    INICloseFile();
  }
}

int TAP_Main(void)
{
  if(!InitTAPex())
  {
    InitTAPexFailedMsg(PROGRAM_NAME);
  }
  else
  {
    CreateRootDir();
    LoadINI();
    UpdateIrDevice();
  }

  return 0;
}
